package bean;

import com.alibaba.fastjson.JSON;
import org.apache.commons.lang3.StringUtils;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.util.HashMap;
import java.util.Map;

/**
 * @program: sunwin_metro
 * @description: 解析输入参数bean
 * @author: xuYJ
 * @create: 2021-06-22 10:31
 **/
public class InputValue implements Serializable {
    /**
     * 故障现象
     */
    private String phenomenonName;
    /**
     * 故障操作
     */
    private String operationName;
    /**
     * 发现故障原因
     */
    private String reasonName;
    /**
     * 故障解决方式
     */
    private String reasonSolve;
    /**
     * 故障发生的部位
     */
    private String locationName;
    /**
     * 故障发生的部位 英文简称
     */
    private String locationAbbreviation;
    /**
     * 故障系统
     */
    private String equipmentName;
    /**
     * 故障系统 英文简称
     */
    private String equipmentAbbreviation;

    public InputValue(String phenomenonName, String operationName, String reasonName, String reasonSolve, String locationName, String locationAbbreviation, String equipmentName, String equipmentAbbreviation) {
        this.phenomenonName = phenomenonName;
        this.operationName = operationName;
        this.reasonName = reasonName;
        this.reasonSolve = reasonSolve;
        this.locationName = locationName;
        this.locationAbbreviation = locationAbbreviation;
        this.equipmentName = equipmentName;
        this.equipmentAbbreviation = equipmentAbbreviation;
    }

    public InputValue() {
    }

    public String getPhenomenonName() {
        return phenomenonName;
    }

    public void setPhenomenonName(String phenomenonName) {
        this.phenomenonName = phenomenonName;
    }

    public String getOperationName() {
        return operationName;
    }

    public void setOperationName(String operationName) {
        this.operationName = operationName;
    }

    public String getReasonName() {
        return reasonName;
    }

    public void setReasonName(String reasonName) {
        this.reasonName = reasonName;
    }

    public String getReasonSolve() {
        return reasonSolve;
    }

    public void setReasonSolve(String reasonSolve) {
        this.reasonSolve = reasonSolve;
    }

    public String getLocationName() {
        return locationName;
    }

    public void setLocationName(String locationName) {
        this.locationName = locationName;
    }

    public String getLocationAbbreviation() {
        return locationAbbreviation;
    }

    public void setLocationAbbreviation(String locationAbbreviation) {
        this.locationAbbreviation = locationAbbreviation;
    }

    public String getEquipmentName() {
        return equipmentName;
    }

    public void setEquipmentName(String equipmentName) {
        this.equipmentName = equipmentName;
    }

    public String getEquipmentAbbreviation() {
        return equipmentAbbreviation;
    }

    public void setEquipmentAbbreviation(String equipmentAbbreviation) {
        this.equipmentAbbreviation = equipmentAbbreviation;
    }

    @Override
    public String toString() {
        return "InputValue{" +
                "phenomenonName='" + phenomenonName + '\'' +
                ", operationName='" + operationName + '\'' +
                ", reasonName='" + reasonName + '\'' +
                ", reasonSolve='" + reasonSolve + '\'' +
                ", locationName='" + locationName + '\'' +
                ", locationAbbreviation='" + locationAbbreviation + '\'' +
                ", equipmentName='" + equipmentName + '\'' +
                ", equipmentAbbreviation='" + equipmentAbbreviation + '\'' +
                '}';
    }

    public static void main(String[] args) throws IllegalAccessException {
        InputValue inputValue = new InputValue(
                "         停电时，逆变不工作       ",
                "       打开机盖，将其取出充电，用一段时间后无故障           ",
                "蓄电池电压过低",
                "拆下蓄电池，先进行均衡充电（所有蓄电池并联进行充电） ，若仍不成功，则只有更换蓄电池",
                "蓄电池",
                "battery",
                "不间断应急电源",
                "ups"
        );
        System.out.println(JSON.toJSONString(inputValue));
        objectToTrim(inputValue);
        System.out.println(JSON.toJSONString(inputValue));
    }
    public static void objectToTrim(Object obj) throws IllegalAccessException {
        Map<String,String> map = new HashMap<>(16);
        Field[] declaredFields = obj.getClass().getDeclaredFields();
        for (Field field:declaredFields){
            String type = field.getType().getCanonicalName();
            if (StringUtils.equals("java.lang.String", type)){
                field.setAccessible(true);
                Object object = field.get(obj);
                if (object != null) {
                    String trim = object.toString().replace(" ","");
                    map.put(field.getName(),trim);
                }
            }
        }
        for (Field field:declaredFields){
            if (map.get(field.getName())!=null){
                String s = map.get(field.getName());
                field.setAccessible(true);
                field.set(obj,s);
            }
        }
    }
}
