package neo4j.controller.dev;


import neo4j.model.dev.*;
import neo4j.repository.dev.*;
import neo4j.bean.InputValue;

import neo4j.relation.dev.EquLoc;
import neo4j.relation.dev.LocRea;
import neo4j.relation.dev.OpeRea;
import neo4j.relation.dev.PheOpe;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.*;

/**
 * @author xuYJ
 */
@RestController
@RequestMapping("/rest/v1.0.1/database")
public class EquipmentController {
    @Autowired
    EquipmentRepository equipmentService;
    @Autowired
    ReasonRepository reasonService;
    @Autowired
    LocationRepository locationService;
    @Autowired
    OperationRepository operationService;
    @Autowired
    PhenomenonRepository phenomenonService;
    @Autowired
    PheOpeRepository pheOpeService;
    @Autowired
    OpeReaRepository opeReaService;
    @Autowired
    LocReaRepository locReaService;
    @Autowired
    EquLocRepository equLocService;


    @RequestMapping("/delete")
    public void getFeatureInfo() {
        List<Phenomenon> byName = phenomenonService.findByName("停电时，逆变不工作");
        for (Phenomenon phenomenon : byName) {
            phenomenonService.delete(phenomenon);
        }
        List<Operation> byName1 = operationService.findByName("打开机盖，将其取出充电，用一段时间后无故障");
        for (Operation operation : byName1) {
            operationService.delete(operation);
        }

        List<Reason> byName2 = reasonService.findByName("蓄电池电压过低");
        for (Reason reason : byName2) {
            reasonService.delete(reason);
        }
    }

    /**
     *新增故障图谱数据
     */
    @PostMapping(value = "/insertRes", produces = "application/json;charset=UTF-8")
    public String insertRes(@RequestBody InputValue inputValue) {
        List<Phenomenon> phenomenon = phenomenonService.findByName(inputValue.getPhenomenonName());
        if (phenomenon.isEmpty()) {
            //找到实体中最大的 abbreviation
            List<String> abbreviation = phenomenonService.findAbbreviation();
            abbreviation.sort((o1, o2) -> {
                Integer reason1 = Integer.valueOf(o1.replaceAll("phenomenon", ""));
                Integer reason2 = Integer.valueOf(o2.replaceAll("phenomenon", ""));
                return reason1 - reason2;
            });
            String num = abbreviation.get(abbreviation.size() - 1).replaceAll("phenomenon", "").trim();
            String phenomenonAbbreviation = "phenomenon"+(Integer.parseInt(num)+1);
            phenomenonService.save(new Phenomenon(inputValue.getPhenomenonName(), phenomenonAbbreviation));
        } else {
            System.out.println("故障现象实体已存在");
        }

        //验证设备系统实体是否存在
        Equipment equipment = equipmentService.findByName(inputValue.getEquipmentName());
        if (null == equipment) {
            equipmentService.save(new Equipment(inputValue.getEquipmentName(), inputValue.getEquipmentAbbreviation()));
        } else {
            System.out.println("设备系统实体存在");
        }

        Location location = locationService.findByName(inputValue.getLocationName());
        if (null == location) {
            locationService.save(new Location(inputValue.getLocationName(), inputValue.getLocationAbbreviation()));
        } else {
            System.out.println("故障发生的部位实体已存在");
        }

        List<Reason> reason = reasonService.findByName(inputValue.getReasonName());
        if (reason.isEmpty()) {
            //找到实体中最大的 abbreviation
            List<String> abbreviation = reasonService.findAbbreviation();
            abbreviation.sort((o1, o2) -> {
                Integer reason1 = Integer.valueOf(o1.replaceAll("reason", ""));
                Integer reason2 = Integer.valueOf(o2.replaceAll("reason", ""));
                return reason1 - reason2;
            });
            String num = abbreviation.get(abbreviation.size() - 1).replaceAll("reason", "").trim();
            String reasonAbbreviation =  "reason"+(Integer.parseInt(num)+1);
            //实体不存在,新增实体
            reasonService.save(new Reason(inputValue.getReasonName(), reasonAbbreviation, inputValue.getReasonSolve()));
        } else {
            System.out.println("故障原因实体已存在");
        }

        List<Operation> operation = operationService.findByName(inputValue.getOperationName());
        if (operation.isEmpty()) {
            //找到实体中最大的 abbreviation
            List<String> abbreviation = operationService.findAbbreviation();
            abbreviation.sort((o1, o2) -> {
                Integer reason1 = Integer.valueOf(o1.replaceAll("operation", ""));
                Integer reason2 = Integer.valueOf(o2.replaceAll("operation", ""));
                return reason1 - reason2;
            });
            String num = abbreviation.get(abbreviation.size() - 1).replaceAll("operation", "").trim();
            String operationAbbreviation = "operation"+(Integer.parseInt(num)+1);
            //实体不存在,新增实体
            operationService.save(new Operation(inputValue.getOperationName(), operationAbbreviation));
        } else {
            System.out.println("故障操作实体已存在");
        }
            Phenomenon phenomenon1 = phenomenonService.findByName(inputValue.getPhenomenonName()).get(0);
            equipment = equipmentService.findByName(inputValue.getEquipmentName());
            Operation operation1 = operationService.findByName(inputValue.getOperationName()).get(0);
            Reason reason1 = reasonService.findByName(inputValue.getReasonName()).get(0);
            location = locationService.findByName(inputValue.getLocationName());
            int count=0;
            List<PheOpe> res1 = pheOpeService.getRes(phenomenon1.getAbbreviation(), operation1.getAbbreviation());
            if(res1.isEmpty()){
                PheOpe res11 = pheOpeService.createRes(phenomenon1.getAbbreviation(), operation1.getAbbreviation(),"建议操作");
                System.out.println("res1 = " + res11);
            }else {
                System.out.println("建议操作关系已存在");
                count++;
            }
            List<OpeRea> res2 = opeReaService.getRes(operation1.getAbbreviation(), reason1.getAbbreviation());
            if(res2.isEmpty()){
                OpeRea res21 = opeReaService.createRes(operation1.getAbbreviation(), reason1.getAbbreviation(),"发现故障原因");
                System.out.println("res2 = " + res21);
            }else {
                System.out.println("发现故障原因关系已存在" );
                count++;
            }
            List<LocRea> res3 = locReaService.getRes(location.getAbbreviation(), reason1.getAbbreviation());
            if(res3.isEmpty()){
                LocRea res31 = locReaService.createRes(location.getAbbreviation(), reason1.getAbbreviation(),"隐患故障点");
                System.out.println("res3 = " + res31);
            }else {
                System.out.println("隐患故障点关系已存在");
                count++;
            }
            List<EquLoc> res4 = equLocService.getRes(equipment.getAbbreviation(), location.getAbbreviation());
            if(res4.isEmpty()){
                EquLoc res41 = equLocService.createRes(equipment.getAbbreviation(), location.getAbbreviation(),"故障部位");
                System.out.println("res4 = " + res41);
            }else {
                System.out.println("故障部位关系已存在");
                count++;
            }
        System.out.println("---------------------------") ;
            if(count==4){
             return "新增关系重复";
            }
            return "关系新增成功";
        }
}
