package neo4j.model.dev;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.neo4j.ogm.annotation.GeneratedValue;
import org.neo4j.ogm.annotation.Id;
import org.neo4j.ogm.annotation.NodeEntity;

/**
 * @program: neo4j-demo
 * @description: 设备系统子部件实体
 * @author: kane
 * @create: 2020-05-27 10:29
 **/
@NodeEntity
@Data
@NoArgsConstructor
@AllArgsConstructor
public class Location {
    @Id
    @GeneratedValue
    private Long id;
    private String name;
    private String abbreviation;

    public Location(String name, String abbreviation) {
        this.name = name;
        this.abbreviation = abbreviation;
    }
}
