package neo4j.relation.dev;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import neo4j.model.dev.Operation;
import neo4j.model.dev.Phenomenon;
import org.neo4j.ogm.annotation.*;

/**
 * @program: neo4j-demo
 * @description: 建议操作关系 （ 故障现象 -> 故障操作）
 * @author: kane
 * @create: 2021-05-27 10:43
 **/
@RelationshipEntity(type = "建议操作")
@Data
@AllArgsConstructor
@NoArgsConstructor
public class PheOpe {
    @Id
    @GeneratedValue
    private Long id;
    private String property;

    @StartNode
    private Phenomenon phenomenon;
    @EndNode
    private Operation operation;

    public PheOpe(Phenomenon phenomenon, Operation operation, String property) {
        this.phenomenon = phenomenon;
        this.operation = operation;
        this.property = property;
    }
}
