package neo4j.relation.test;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import neo4j.model.test.Device;
import neo4j.model.test.Feature;
import org.neo4j.ogm.annotation.*;

/**
 * @program: neo4j-demo
 * @description:
 * @author: Jamie.shi
 * @create: 2020-05-27 10:43
 **/
@RelationshipEntity
@Data
@AllArgsConstructor
@NoArgsConstructor
public class DeviceFeature {
    @Id
    @GeneratedValue
    private Long id;
    private String property;

    @StartNode
    private Device device;
    @EndNode
    private Feature feature;

    public DeviceFeature(Device device, Feature feature, String property) {
        this.device = device;
        this.feature = feature;
        this.property = property;
    }

}
