package neo4j.repository.dev;

import neo4j.relation.dev.LocRea;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;

import java.util.List;

/**
 * @program: neo4j-demo
 * @description: 系统 -> 故障部位关系
 * @author: xuYJ
 * @create: 2021-03-17 15:40
 **/
public interface LocReaRepository extends Neo4jRepository<LocRea, Long> {
    /**
     * 为两个已经存在的节点添加关系
     * @param start -- 起始节点
     * @param end   -- 终止节点
     */
    @Query("match(a),(b) where a.abbreviation = {0} and b.abbreviation = {1} "
            + " create p = (a)-[r: 隐患故障点 {property:{2}} ] -> (b) return p ")
    LocRea createRes(String start, String end ,String res);

    /**
     * 查询关系是否存在
     */
    @Query("match p = (n)-[r:隐患故障点]- (b) where n.abbreviation={0} and b.abbreviation={1} return p")
    List<LocRea> getRes(String loc, String rea );
}
