package neo4j.repository.dev;

import neo4j.model.dev.Operation;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * @program: neo4j-demo
 * @description:
 * @author: kane
 * @create: 2020-05-27 10:37
 **/
public interface OperationRepository extends Neo4jRepository<Operation, Long> {

    /**
     * 根据名字查找
     * @param name
     * @return
     */
    List<Operation> findByName(@Param("name") String name);

    /**
     * 查询所有 abbreviation
     */
    @Query("MATCH (n:Operation) RETURN n.abbreviation ")
    List<String> findAbbreviation();
}
