package neo4j.repository.test;


import neo4j.relation.test.DeviceFeature;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;


import java.util.List;

/**
 * @program: neo4j-demo
 * @description: 系统->设备关系
 * @author: xuYJ
 * @create: 2021-03-17 15:40
 **/
public interface DeviceFeatureRepository extends Neo4jRepository<DeviceFeature, Long> {
    /**
     * 返回某设备所有设备属性
     */
    @Query("MATCH p=(a)-[r:DeviceFeature]->(b) WHERE a.name= {name} RETURN p")
    List<DeviceFeature> findDeviceFeatures(String name);

    /**
     * 返回所有设备所有设备属性
     */
    @Query("MATCH p=(a)-[r:DeviceFeature]->(b)  RETURN p")
    List<DeviceFeature> findDeviceFeatures();
}
